%{
/*
// THIS FILE IS COPYRIGHT 1994 BY TELENOR RESEARCH, NORWAY
//
//                    ALL RIGHTS RESERVED.
//
// For rights granted to the public see the COPYRIGHT file
*/

/* Programming : Jon Stephenson von Tetzchner */

#include <stdio.h>
%}
MIFSTART  	"<MIFFile".*">".*"#".*"\n"
MIFEND    	"# End".*"MIFFile"
PageStart  	"<Page"[ \t]*"\n"
PageType	"<PageType"[ \t].*">"
ImportObjectStart	"<ImportObject"[ \t]*"\n"
ImportObFile	"<ImportObFile"[ \t].*">"
ImportObFileDI	"<ImportObFileDI"[ \t].*">"
BRect		"<BRect".*">"
Angle		"<Angle".*">"
FlipLR		"<FlipLR".*">"
ImportObjectEnd	">".*"ImportObject"[ \t]*"\n"
PageEnd      	">".*"Page"[ \t]*"\n"
PgfCatalogStart	"<PgfCatalog"[ \t]*"\n"
PgfCatalogEnd	">".*"PgfCatalog"[ \t]*"\n"
ParaStart	"<Para"[ \t]*"\n"
PGFTAG    	"<PgfTag".*">"
PgfAlignment	"<PgfAlignment".*">"
PgfTopSeparator	"<PgfTopSeparator".*">"
PgfBotSeparator	"<PgfBotSeparator".*">"
PgfStart	"<Pgf"[ \t]*"\n"
PgfNumberFont	"<PgfNumberFont".*">"
PgfFontStart 	"<PgfFont"[ \t]*"\n"
PgfFontEnd	">".*"PgfFont"[ \t]*"\n"
STRING    	"<String".*">"
PgfEnd		">".*"Pgf"[ \t]*"\n"
PgfNumString	"<PgfNumString".*">"
ParaLine	"<ParaLine"[ \t]*"\n"
ParaEnd		">".*"Para"[ \t]*"\n"
FontCatalogStart	"<FontCatalog"[ \t]*"\n"
FontCatalogEnd	">".*"FontCatalog"[ \t]*"\n"
FTAG    	"<FTag".*">"
FontStart 	"<Font"[ \t]*"\n"
FFamily         "<FFamily".*">"
FWeight		"<FWeight".*">"
FAngle		"<FAngle".*">"
FUnderline	"<FUnderline".*">"
FSupscript	"<FSupScript".*">"
FSubscript	"<FSubScript".*">"
FUnderline4     "<FUnderlining"[ \t]*"FSingle>"
FSupscript4     "<FPosition"[ \t]*"FSuperscript>"
FSubscript4     "<FPosition"[ \t]*"FSubscript>"
FontEnd		">".*"Font"[ \t]*"\n"
TblCatalogStart	"<TblCatalog"[ \t]*"\n"
TblCatalogEnd	">".*"TblCatalog"[ \t]*"\n"
FNoteUse  	"<FNote ".*">".*"\n"
FNoteStart  	"<FNote"[ \t]*"\n"
FNoteEnd  	">".*"FNote"[ \t]*"\n"
XRefStart 	"<XRef"[ \t]*"\n"
XRefSrcText 	"<XRefSrcText".*">"
XRefSrcFile	"<XRefSrcFile".*">"
XRefEnd   	"<XRefEnd".*">"
AFramesStart	"<AFrames"[ \t]*"\n"
AFramesEnd	">".*"AFrames"[ \t]*"\n"
AFrameUse	"<AFrame".*">"
FrameStart	"<Frame"[ \t]*"\n".*"<ID".*">"
IntFrameStart	"<Frame"[ \t]*"\n"
FrameEnd	">".*"Frame"[ \t]*"\n"
FrameType 	"<FrameType".*">"
TablesStart	"<Tbls"[ \t]*"\n"
TableStart	"<Tbl"[ \t]*"\n"
TableID		"<TblID".*">"
TableFormatStart	"<TblFormat"[ \t]*"\n"
TableFormatEnd	">".*"TblFormat"[ \t]*"\n"
TableNumColumns	"<TblNumColumns".*">"
TableTitleStart	"<TblTitleContent"[ \t]*"\n"
TableTitleEnd	">".*"TblTitleContent"[ \t]*"\n"
TableHeadStart	"<TblH"[ \t]*"\n"
TableHeadEnd	">".*"TblH"[ \t]*"\n"
TableBodyStart	"<TblBody"[ \t]*"\n"
TableBodyEnd	">".*"TblBody"[ \t]*"\n"
TableFootStart	"<TblF"[ \t]*"\n"
TableFootEnd	">".*"TblF"[ \t]*"\n"
TableRowStart	"<Row"[ \t]*"\n"
TableCellStart 	"<Cell"[ \t]*"\n"
TableCellColumns	"<CellColumns".*">"
TableCellEnd	">".*"Cell"[ \t]*"\n"
TableRowEnd	">".*"Row"[ \t]*"\n"
TableEnd	">".*"Tbl"[ \t]*"\n"
TablesEnd	">".*"Tbls"[ \t]*"\n"
TableUse	"<ATbl".*">"
MarkerType      "<MType".*">"
MarkerText	"<MText".*">"
TextFlowStart	"<TextFlow".*"\n"
TextFlowTag	"<TFTag".*">"
TextRectID	"<TextRectID".*">"
TextFlowEnd	">".*"TextFlow"[ \t]*"\n"
TextRectStart	"<TextRect".*"\n".*"<ID".*">"
TextRectEnd	">".*"TextRect"[ \t]*"\n"
SpecialChar	"<Char".*">"
KILL      	("#"|">"|"<"|"&"|"="|[a-zA-Z]|[0-9]|[,\"`'.{}!@#$%&:;~]|"["|"]"|"("|")"|"*"|"+"|"="|"/"|"\\"|"^"|"-").*
SPACE     	[ \t]+  
VariStart	"<Variable"[ \t]*"\n"
VariName	"<VariableName".*">\n"
VariEnd		">".*"Variable"[ \t]*"\n"
VariFormsStart	"<VariableFormats"[ \t]*"\n"
VariFormStart	"<VariableFormat"[ \t]*"\n"
VariDef		"<VariableDef".*">\n"
VariFormEnd	">".*"VariableFormat"[ \t]*"\n"
VariFormsEnd	">".*"VariableFormats"[ \t]*"\n"
%%
{MIFSTART}  		{return MIFSTART;}
{MIFEND}		{return MIFEND;}
{PageStart}		{return PAGESTART;}
{PageType}		{return PAGETYPE;}
{ImportObjectStart}	{return IMPORTOBJECTSTART;}
{ImportObFile}		{return IMPORTOBFILE;}
{ImportObFileDI}	{return IMPORTOBFILEDI;}
{BRect}			{return BRECT;}
{Angle}			{return ANGLE;}
{FlipLR}		{return FLIPLR;}
{ImportObjectEnd}	{return IMPORTOBJECTEND;}
{PageEnd}		{return PAGEEND;}
{PgfCatalogStart}	{return PGFCATALOGSTART;}
{PgfCatalogEnd}		{return PGFCATALOGEND;}
{ParaStart}		{return PARASTART;}
{PGFTAG}    		{return PGFTAG;}
{PgfAlignment}		{return PGFALIGNMENT;}
{PgfTopSeparator}	{return PGFTOPSEPARATOR;}
{PgfBotSeparator}	{return PGFBOTSEPARATOR;}
{PgfStart}		{return PGFSTART;}
{PgfNumberFont}		{return PGFNUMBERFONT;}
{PgfFontStart}	        {return PGFFONTSTART;}
{PgfFontEnd}	        {return PGFFONTEND;}
{STRING}    		{return STRING;}
{PgfEnd}		{return PGFEND;}
{PgfNumString}		{return PGFNUMSTRING;}
{ParaLine}		{return PARALINE;}
{ParaEnd}		{return PARAEND;}
{FontCatalogStart}	{return FONTCATALOGSTART;}
{FontCatalogEnd}	{return FONTCATALOGEND;}
{FontStart}	        {return FONTSTART;}
{FTAG}    		{return FTAG;}
{FFamily}	        {return FFAMILY;}
{FWeight}	        {return FWEIGHT;}
{FAngle}	        {return FANGLE;}
{FUnderline}	        {return FUNDERLINE;}
{FSupscript}		{return FSUPERSCRIPT;}
{FSubscript}		{return FSUBSCRIPT;}
{FUnderline4}	        {return FUNDERLINE;}
{FSupscript4}		{return FSUPERSCRIPT;}
{FSubscript4}		{return FSUBSCRIPT;}
{FontEnd}	        {return FONTEND;}
{TblCatalogStart}	{return TBLCATALOGSTART;}
{TblCatalogEnd}		{return TBLCATALOGEND;}
{FNoteUse}  		{return FNOTEUSE;}
{FNoteStart}  		{return FNOTESTART;}
{FNoteEnd}  		{return FNOTEEND;}
{XRefStart} 		{return XREFSTART;}
{XRefSrcText}		{return XREFSRCTEXT;}
{XRefSrcFile}		{return XREFSRCFILE;}
{XRefEnd}   		{return XREFEND;}
{AFramesStart}		{return AFRAMESSTART;}
{AFramesEnd}		{return AFRAMESEND;}
{FrameStart}		{return FRAMESTART;}
{IntFrameStart}		{return INTFRAMESTART;}
{FrameEnd}		{return FRAMEEND;}
{FrameType}		{return FRAMETYPE;}
{AFrameUse}		{return AFRAMEUSE;}
{TablesStart}		{return TABLESSTART;}
{TableStart}		{return TABLESTART;}
{TableID}		{return TABLEID;}
{TableFormatStart}	{return TABLEFORMATSTART;}
{TableFormatEnd}	{return TABLEFORMATEND;}
{TableNumColumns}	{return TABLENUMCOLUMNS;}
{TableTitleStart}	{return TABLETITLESTART;}
{TableTitleEnd}		{return TABLETITLEEND;}
{TableHeadStart}	{return TABLEHEADSTART;}
{TableHeadEnd}		{return TABLEHEADEND;}
{TableBodyStart}	{return TABLEBODYSTART;}
{TableBodyEnd}		{return TABLEBODYEND;}
{TableFootStart}	{return TABLEFOOTSTART;}
{TableFootEnd}		{return TABLEFOOTEND;}
{TableRowStart}		{return TABLEROWSTART;}
{TableCellStart}	{return TABLECELLSTART;}
{TableCellColumns}	{return TABLECELLCOLUMNS;}
{TableCellEnd}		{return TABLECELLEND;}
{TableRowEnd}		{return TABLEROWEND;}
{TableEnd}		{return TABLEEND;}
{TablesEnd}		{return TABLESEND;}
{TableUse}		{return TABLEUSE;}
{MarkerType}		{return MARKERTYPE;}
{MarkerText}		{return MARKERTEXT;}
{TextFlowStart}		{return TEXTFLOWSTART;}	
{TextFlowTag}		{return TEXTFLOWTAG;}	
{TextRectID}		{return TEXTRECTID;}	
{TextFlowEnd}		{return TEXTFLOWEND;}	
{TextRectStart}	        {return TEXTRECTSTART;}
{TextRectEnd}	        {return TEXTRECTEND;}
{SpecialChar}	        {return SPECIALCHAR;}
"\n"        		{}
{KILL}      		{PrintFrameItem();}
{SPACE}     		{}
{VariStart}		{return VARISTART;}
{VariName}		{return VARINAME;}
{VariEnd}		{return VARIEND;}
{VariFormsStart}	{return VARIFORMSSTART;}
{VariFormStart}		{return VARIFORMSTART;}
{VariDef}		{return VARIDEF;}
{VariFormEnd}		{return VARIFORMEND;}
{VariFormsEnd}		{return VARIFORMSEND;}
%%

/* Added as it seems it has been moved to the flex library on some systems */
#ifndef yywrap
int yywrap()
{
    return 1;
}
#endif
